package test.forum.json;
import java.net.URI;
import java.util.Date;
import java.util.List;
import java.util.Map;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyAttribute;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.namespace.QName;

@XmlAccessorType(XmlAccessType.NONE)
@XmlRootElement(name = OprEvtStatisticRecord.XML_NAME)
@XmlType(name = OprEvtStatisticRecord.XML_TYPE,
         propOrder = {"startDate", "interval", "type", "value", "serverName", "any"})
public final class OprEvtStatisticRecord extends OprResourceBase
{
  private static final long serialVersionUID = -5789774929709754974L;

  public static final String XML_NAME = "event_statistic_record";
  public static final String XML_TYPE = XML_NAME + "_type";
  public static final String TYPE = OprResourceBase.BASE_TYPE + XML_NAME;
  public static final String BASE_REF_TYPE = OprResourceBase.BASE_REF_TYPE + XML_NAME + ":";
  public static final URI TYPE_URI = URI.create(TYPE);

  private Date m_startDate;
  private Long m_interval;
  private OprEvtStatisticsType m_type;
  private Long m_value;
  private String m_serverName;

  private List<Object> m_any;
  private Map<QName, Object> m_anyAttribute;

  public OprEvtStatisticRecord()
  {
    super(TYPE_URI, VERSION);
  }

  @XmlAnyElement(lax = true)
  public List<Object> getAny()
  {
    return m_any;
  }

  @Override
  public void setAny(List<Object> any)
  {
    m_any = any;
  }

  @XmlAnyAttribute
  public Map<QName, Object> getAnyAttribute()
  {
    return m_anyAttribute;
  }

  @Override
  public void setAnyAttribute(Map<QName, Object> anyAttribute)
  {
    m_anyAttribute = anyAttribute;
  }


  @XmlElement(name = "start")
  public Date getStartDate()
  {
    return m_startDate;
  }


  public void setStartDate(Date value)
  {
    this.m_startDate = value;
  }

  @XmlElement(name = "interval")
  public long getInterval()
  {
    return m_interval;
  }


  public void setInterval(long value)
  {
    this.m_interval = value;
  }

  @XmlElement(name = "type")
  public OprEvtStatisticsType getType()
  {
    return m_type;
  }


  public void setType(OprEvtStatisticsType value)
  {
    this.m_type = value;
  }


  @XmlElement(name = "value")
  public Long getValue()
  {
    return m_value;
  }


  public void setValue(Long value)
  {
    this.m_value = value;
  }


  @XmlElement(name = "server")
  public String getServerName()
  {
    return m_serverName;
  }


  public void setServerName(String value)
  {
    this.m_serverName = value;
  }


  @Override
  public int hashCode()
  {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((m_type == null) ? 0 : m_type.hashCode());
    result = prime * result + ((m_serverName == null) ? 0 : m_serverName.hashCode());
    result = prime * result + ((m_startDate == null) ? 0 : m_startDate.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    OprEvtStatisticRecord other = (OprEvtStatisticRecord) obj;
    if (m_type != other.m_type)
      return false;
    if (m_serverName == null)
    {
      if (other.m_serverName != null)
        return false;
    }
    else if (!m_serverName.equals(other.m_serverName))
      return false;
    if (m_startDate == null)
    {
      if (other.m_startDate != null)
        return false;
    }
    else if (!m_startDate.equals(other.m_startDate))
      return false;
    return true;
  }
}
